static char *cvs_id =" $Id: xy_excl.c,v 1.4 2002/12/05 16:20:17 berar Exp $ ";
/*  bm_stat : image princeton (Winview ) et autres    */
/*  jfberar   berar@esrf.fr */

#include <stdlib.h>
#include <stdio.h>
#include <math.h>
#include <string.h>
#include <errno.h>
#include <ctype.h>
/*-----------------------------------------------------------*/
#include "xy_def.h"

ZONE *excluded = NULL;
int  n_excluded = 0;
int  m_excluded = 0;
char *quiet;
/*-----------------------------------------------------------*/
static int pixel_off( INT16U x, INT16U y, IMAGE *img, unsigned char mod, INT32 v); 
static int pixel_on( INT16U x, INT16U y, IMAGE *img); 
static int excl_pixel( ZONE *l_excl, IMAGE *img, int print);
static int excl_circ ( ZONE *l_excl, IMAGE *img, int print);
static int excl_rect ( ZONE *l_excl, IMAGE *img, int print);
static int excl_tria ( ZONE *l_excl, IMAGE *img, int print);
static int excl_file ( ZONE *l_excl, IMAGE *img, int print);
/*-----------------------------------------------------------*/
void excl_ini(int excl_type, char *line )
{  int i, x, y, r, m, v;
   char *bline;
   ZONE * l_excl;
	char *excl_roi;
   i = n_excluded++;
   if (excluded==NULL ) 
   {  excluded = (ZONE *) malloc( (m_excluded+10) *sizeof(ZONE));
      m_excluded +=10;
      }
   else if (n_excluded > m_excluded ) 
   {  excluded = (ZONE *) realloc(excluded, (m_excluded+10) *sizeof(ZONE));
	   m_excluded +=10;
      }
    l_excl = excluded+i;
	 l_excl->v = 0;
	 l_excl->t = excl_type;
    bline = strchr(line, '=');
    if ( bline ) bline ++;
    else { bline = line; }
    l_excl->file_name=NULL;
	 quiet = strstr(line, "QUIET");
	 excl_roi = (excl_type & ROI ) ? "_ROI" : "_EXCLUDED";
	 switch ( excl_type & ~ ROI )
	 {  case P_EXCL : m = sscanf(bline,"%hd%hd%d", &(l_excl->x1), &(l_excl->y1),
	         &(l_excl->v)); 
	      l_excl->m =  (m==3) ? 1 : 0;
         if (!quiet) printf(" add P%s point x %d y %d", excl_roi, l_excl->x1, l_excl->y1); 
			break;
	    case C_EXCL : m = sscanf(bline,"%hd%hd%hd%d", &l_excl->x1, &l_excl->y1,
	         &l_excl->x2, &l_excl->v); 
	      l_excl->m =  (m==4) ? 1 : 0;
         if (!quiet) printf(" add C%s circle x %d y %d r %d", excl_roi, l_excl->x1, l_excl->y1,
			  l_excl->x2); 
			break;
	    case R_EXCL : m = sscanf(bline,"%hd%hd%hd%hd%d", &l_excl->x1, &l_excl->y1,
	         &l_excl->x2, &l_excl->y2, &l_excl->v); 
	      l_excl->m =  (m==5) ? 1 : 0;
         if (!quiet) printf(" add R%s rectangle x1 %d y1 %d x2 %d y2 %d", excl_roi, l_excl->x1, l_excl->y1,
			  l_excl->x2, l_excl->y2); 
			break;
	    case T_EXCL : m = sscanf(bline,"%hd%hd%hd%hd%hd%hd%d",&l_excl->x1, &l_excl->y1, 
	       &l_excl->x2, &l_excl->y2, &l_excl->x3, &l_excl->y3,
			 &l_excl->v); 
	      l_excl->m =  (m==7) ? 1 : 0;
         if (!quiet) printf(" add T%s triangle x1 %d y1 %d x2 %d y2 %d x3 %d y3 %d", excl_roi, l_excl->x1, l_excl->y1,
			  l_excl->x2, l_excl->y2, l_excl->x3, l_excl->y3); 
			break;
	    case F_EXCL : l_excl->m=0;
         l_excl->file_name=str_alloc(line);
         break;
		 }
       if (!quiet)  
		 {  if (l_excl->m ) printf(" (modify to %d)\n", l_excl->v);
		    else printf("\n"); }
       }
/*-----------------------------------------------------------*/
void excl_image ( IMAGE *img, int print)
{  INT16U * frame, *saved_frame;
   long i, j, ne = 0;
   int roi =0;
   int mask =0;
	INT32 v = 0;
   int ninc=img->size;
   if ( n_excluded == 0 ) return;
   for (i=0; i < n_excluded; i++) if ( excluded[i].t & ROI ) roi++; else mask++;
	saved_frame = img->frame;
	frame = (INT16U *) prg_alloc("xy_excl", "roi frame buffer", img->size * sizeof(INT16U), 1);
	img->frame = frame;
   for (i=0; i < n_excluded; i++) if ( excluded[i].t & ROI ) roi++; 
	if (roi)
	{  int ninc=0;
	   for (i=0; i < n_excluded; i++)
      {  switch ( excluded[i].t )
		   {  case C_EXCL+ROI : ninc += excl_circ (excluded+i, img, print); break;
		      case R_EXCL+ROI : ninc += excl_rect (excluded+i, img, print); break;
		      case T_EXCL+ROI : ninc += excl_tria (excluded+i, img, print); break;
		      }
		    }
	   for (i=0; i<img->size; i++) if (frame[i] == 0) img->data[i] = 0;
      printf("# %d included pixel(s) in %d roi(s) for calculations\n", ninc, roi);
		}	 		
   else 
   {  for (i=0; i<img->size; i++) frame[i] = 1;
      }
	if (mask)
   {  for (i=0; i < n_excluded; i++)
      {  switch ( excluded[i].t )
		   {  case P_EXCL : ne += excl_pixel(excluded+i, img, print); break;
		      case C_EXCL : ne += excl_circ (excluded+i, img, print); break;
		      case R_EXCL : ne += excl_rect (excluded+i, img, print); break;
		      case T_EXCL : ne += excl_tria (excluded+i, img, print); break;
		      case F_EXCL : ne += excl_file (excluded+i, img, print); break;
            }
		   }
      printf("# %d excluded pixel(s) by %d mask(s) for calculations\n", ne, mask);
		}	 
   if (saved_frame)
   {	for (i=0; i<img->size; i++) if (saved_frame[i] == 0) img->frame[i] = 0;
      free(saved_frame);	
      }	 
   }
/*-----------------------------------------------------------*/
static int pixel_off( INT16U x, INT16U y, IMAGE *img, unsigned char mod, INT32 v)
{  long j;
   if ( x < img->x_omin || x >= img->x_omax ) return 0;
   if ( y < img->y_omin || y >= img->y_omax ) return 0;
   j = (y-img->y_omin)/img->y_obind * img->x_size + (x-img->x_omin)/img->x_obind;
/* printf(" %d %d  m %d v %d  f %d\n", x, y, mod, v, img->frame[j]); */
   if (img->frame[j]==0 ) return 0;
   img->frame[j]=0;
	if (mod) 
	{  if ( v == -1 )
	   {  long jj, vv, nn;
		   nn = vv =0;
			if (x!=0)
			{ jj = (y-img->y_omin)/img->y_obind * img->x_size + (x-1-img->x_omin)/img->x_obind;
           if (img->frame[jj]) { vv+=img->data[jj]; nn++;}
			  }
			if (x!=img->x_size-2)
			{  jj = (y-img->y_omin)/img->y_obind * img->x_size + (x+1-img->x_omin)/img->x_obind;
            if (img->frame[jj]) { vv+=img->data[jj]; nn++;}
				}
			if (y!=0)
			{ jj = (y-1-img->y_omin)/img->y_obind * img->x_size + (x-img->x_omin)/img->x_obind;
           if (img->frame[jj]) { vv+=img->data[jj]; nn++;}
			  }
			if (y!=img->y_size-2)
			{  jj = (y+1-img->y_omin)/img->y_obind * img->x_size + (x-img->x_omin)/img->x_obind;
            if (img->frame[jj]) { vv+=img->data[jj]; nn++;}
				}
		   if (nn) vv/=nn;
			img->data[j] = vv;
			}
	   else img->data[j] = v;
		}
	return 1;
   }
/*-----------------------------------------------------------*/
static int pixel_on( INT16U x, INT16U y, IMAGE *img)
{  long j;
   if ( x < img->x_omin || x >= img->x_omax ) return 0;
   if ( y < img->y_omin || y >= img->y_omax ) return 0;
   j = (y-img->y_omin)/img->y_obind * img->x_size + (x-img->x_omin)/img->x_obind;
/* printf(" %d %d  m %d v %d  f %d\n", x, y, mod, v, img->frame[j]); */
   if (img->frame[j]!=0 ) return 0;
   img->frame[j]=1;
	return 1;
   }
/*-----------------------------------------------------------*/
static int excl_pixel( ZONE *l_excl, IMAGE *img, int print)
{  int n = 0;
	char *t = (l_excl->t & ROI) ? "includ": "exclud" ;
	if ((print & 32)) printf("# %sing pixel %d %d\n", t, l_excl->x1, l_excl->y1); 
   if ( l_excl->t & ROI ) n += pixel_on ( l_excl->x1, l_excl->y1, img);
   else n += pixel_off ( l_excl->x1, l_excl->y1, img, l_excl->m, l_excl->v);
   return n;
	}    
/*-----------------------------------------------------------*/
static int excl_circ ( ZONE *l_excl, IMAGE *img, int print)
{  INT16U rx, ry;
   int ix, iy, ro, r2;
   int n = 0;
	char *t = (l_excl->t & ROI) ? "includ": "exclud" ;
	if ((print & 32)) printf("# %sing circle %d %d radius %d ", t, l_excl->x1, l_excl->y1,
	   l_excl->x2); 
   ro = l_excl->x2;
	r2 = ro*ro;
   for ( ix = -ro; ix <= ro; ix++ )
   {  rx = ix + l_excl->x1;
      if ( rx < img->x_omin || rx >= img->x_omax ) continue;
      for ( iy = -ro; iy <= ro; iy++ )
      {  ry = iy + l_excl->y1;
         if ( ry < img->y_omin || ry >= img->y_omax ) continue;
         if ( ix*ix+iy*iy <= r2 )
	        if (l_excl->t & ROI) n += pixel_on ( rx, ry, img);
           else  n += pixel_off ( rx, ry, img, l_excl->m, l_excl->v);
		   }
	  }    
	if ((print & 32)) printf(" : %d pixels %sed\n", n, t);
   return n;
  }
/*-----------------------------------------------------------*/
static int excl_rect ( ZONE *l_excl, IMAGE *img, int print)
{  INT16U rx, ry;
   int x1, x2, y1, y2;
   int n = 0;
	char *t = (l_excl->t & ROI) ? "includ": "exclud" ;
	if ((print & 32)) printf("# %sing rectangle %d %d %d %d ", t, l_excl->x1, l_excl->y1,
	   l_excl->x2, l_excl->y2); 
   x1 =  l_excl->x2 < l_excl->x1 ? l_excl->x2 : l_excl->x1;
   x2 =  l_excl->x2 < l_excl->x1 ? l_excl->x1 : l_excl->x2;
   y1 =  l_excl->y2 < l_excl->y1 ? l_excl->y2 : l_excl->y1;
   y2 =  l_excl->y2 < l_excl->y1 ? l_excl->y1 : l_excl->y2;
   for ( rx = x1; rx <= x2; rx++ )
     for ( ry = y1; ry <= y2; ry++ )
	    if (l_excl->t & ROI) n += pixel_on ( rx, ry, img);
       else n += pixel_off ( rx, ry, img, l_excl->m, l_excl->v);
	if ((print & 32)) printf(" : %d pixels %sed\n", n, t);
   return n;
  }
/*-----------------------------------------------------------*/
static int excl_tria ( ZONE *l_excl, IMAGE *img, int print)
{  INT16U rx, ry;
   int x1, x2, y1, y2;
	float x12, y12, x13, y13, x23, y23;
	float a12, b12, a13, b13, a23, b23;
   int n = 0;
	char *t = (l_excl->t & ROI) ? "includ": "exclud" ;
	if ((print & 32)) printf("# %sing triangle %d %d  %d %d   %d %d ", 
	   t, l_excl->x1, l_excl->y1, l_excl->x2, l_excl->y2, l_excl->x3, l_excl->y3);
   x1 =  l_excl->x2 < l_excl->x1 ? l_excl->x2 : l_excl->x1;
   if (l_excl->x3 < x1 ) x1 = l_excl->x3;
   x2 =  l_excl->x2 < l_excl->x1 ? l_excl->x1 : l_excl->x2;
   if (l_excl->x3 > x2 ) x2 = l_excl->x3;
   y1 =  l_excl->y2 < l_excl->y1 ? l_excl->y2 : l_excl->y1;
   if (l_excl->y3 < y1 ) y1 = l_excl->y3;
   y2 =  l_excl->y2 < l_excl->y1 ? l_excl->y1 : l_excl->y2;
   if (l_excl->y3 > y2 ) y2 = l_excl->y3;
   /* we check only for point inside the rectangle x1 y1, x2 y2 */
	/* float is due to conversion problem arrising on IBM AIX */
	y13 = (float) l_excl->y3 - (float) l_excl->y1;
	y12 = (float) l_excl->y2 - (float) l_excl->y1;
	y23 = (float) l_excl->y3 - (float) l_excl->y2;
	x13 = (float) l_excl->x3 - (float) l_excl->x1;
	x12 = (float) l_excl->x2 - (float) l_excl->x1;
	x23 = (float) l_excl->x3 - (float) l_excl->x2;
	a23 = x12 * y13 - y12 * x13;
	a13 = x12 * y23 - y12 * x23;
	a12 = x13 * y23 - y13 * x23;
/*   printf("\n x %d %d y %d %d  xy %.2f %.2f %.2f  %.2f  %.2f %.2f\n alpha %.2f %.2f %.2f\n",
	 x1, x2, y1, y2, x12,x13, x23, y12, y13, y23, a12, a13, a23);  */
	if (a12) for ( rx = x1; rx <= x2; rx++ )
   for ( ry = y1; ry <= y2; ry++ )
	{  b23 = (x12 *((float) l_excl->y3 - ry)- y12 *((float) l_excl->x3 - rx))/a23;
	   b12 = (-x13 *((float) l_excl->y2 - ry)+ y13 *((float) l_excl->x2 - rx))/a12;
	   b13 = (x23 *((float) l_excl->y1 - ry)- y23 *((float) l_excl->x1 - rx))/a13;
/* 	   printf(" %d %d --> %.2f %.2f %.2f\n", rx, ry, b12, b13, b23);*/
		if (( b12 >= 0 && b12 <= 1) && ( b13 >= 0 && b13 <= 1) &&( b23 >= 0 && b23 <= 1))
		   if (l_excl->t & ROI) n += pixel_on ( rx, ry, img);
         else n += pixel_off(rx, ry, img, l_excl->m, l_excl->v);
			}
	if ((print & 32)) printf(" : %d pixels %sed\n", n,t );
   return n;
  }
/*-----------------------------------------------------------*/
/* use a pseudo image to read the frame mask                 */
static int excl_file ( ZONE *l_excl, IMAGE *img, int print)
/*{  INT16U rx, ry;
*/{  IMAGE image;
   long i;
   int  n = 0;
   INT32 *value;
   INT16S *frame;
   XY_HDR *hdr;
	char *t = (l_excl->t & ROI) ? "includ" : "exclud";
   
   xy_imgini ( &image, img);

	if ((print & 32)) printf("# %sing file_mask = '%s'", t, l_excl->file_name);
   memset(&image, 0, sizeof(IMAGE));
	image.name = l_excl->file_name;;
   image.header = xy_open (image.name, prg_name, 0, NULL, 0, 0); 
   value = xy_getsum(&image, stdout, 0, 1, 0 );
   xy_info(&image, 0);
   n=image.size-image.info.nzero;
   for (i=0; i<img->size;i++) if ( value[i]==0 ) 
   {  img->frame[i]=0;
      img->data[i]=0;
      }
	if ((print & 32)) printf(" : %d pixels %sed\n", n,t );
   xy_fputinfo( stdout, &image);
   xy_freeimg (&image, 3);
   return n;
  }
/*-----------------------------------------------------------*/
/* build a pseudo image and write with    standart procedure */
void excl_save  ( char *name, IMAGE *img)
{   long i;
    INT32 *saved_data, *frame_data;
    char  *saved_name, frame_name[200];
    char *ng, *ne, *nt, *nd;
    INFO saved_info;
    printf("saving frame into mask file\n");
    if (img->frame == NULL) V_ERROR("no frame to write");
    saved_data=img->data;
    img->data=frame_data= (INT32 *) prg_alloc(__FILE__, "frame_data", img->size * sizeof(INT32), 0);
    for (i=0;i<img->size;i++ ) frame_data[i]=img->frame[i];
    while ( name && (*name == '=' || *name == ' ' )) name++;
    saved_name=img->name;
    img->name=frame_name;
    ng = strstr(name, ".gel");
    ne = strstr(name, ".edf");
    nt = strstr(name, ".txt");
    nd = strstr(name, ".tif");
    if ( name && *name==0 )   strcpy(frame_name,"mask.tif");
    else if ( name && ( ng == name || ne == name || nt == name || nd == name ))
    {  strcpy(frame_name,"mask");
       strcat(frame_name,name);
       }
    else strcpy(frame_name,name);
	 memcpy( &saved_info, & img->info, sizeof(INFO));
    xy_info(img, 0);  /* set min and max before output */
    if ( ng )       gel_write(img, ".gel", 1) ;
    else if ( ne)   edf_write(img, T_INT32);
    else if ( nt)   txt_write(img);
    else            gel_write(img, ".tif", 1); /* must be 2 but reading pb */
   free(frame_data);
   img->data=saved_data;
   img->name=saved_name;
	memcpy(&img->info, &saved_info, sizeof(INFO));
   xy_fputinfo(stdout, img);
   }
/*-----------------------------------------------------------*/
   
