static char *cvs_id =" $Id: xy_grid.c,v 1.7 2002/12/05 16:20:17 berar Exp $ ";
/*-----------------------------------------------------------*/
/* grid correction xy_grid.c                                   */
/*-----------------------------------------------------------*/
#include <stdlib.h>
#include <stdio.h>
#include <math.h>
#include <string.h>
#include <errno.h>
#include <ctype.h>
/*-----------------------------------------------------------*/
#define DBG 1
#include "xy_def.h"
/*typedef struct {  int alloc, size;  double *xcor, *ycor; }  extern GRID_COR grid;*/
/* being here is initialized by defect */
GRID_COR grid_cor = {0,0,0,NULL,NULL};
static char * grid_mode = NULL;
char * grid_orig = NULL;
/*-----------------------------------------------------------*/
int  grid_ini ( GRID_COR *grid, char * tag, char * arg)
{  int n;
   if ( prg_iniint(tag, arg, "GRID_DCOR", &n)) 
   {  grid_struct_ini ( grid, n); 
      return 1;
      } 
   if ( grid->xcor && prg_inidbln(tag, arg, "GRID_XCOR", grid->xcor, grid->size)) 
   {  grid->valid |= 1;
      return 1;
      }
   if ( grid->ycor && prg_inidbln(tag, arg, "GRID_YCOR", grid->ycor, grid->size)) 
   {  grid->valid |= 2;
      return 1;
      }
   if ( prg_inistr(tag, arg, "GRID_MODE", & grid_mode)) return 1;
   if ( prg_inistr(tag, arg, "GRID_ORIG", & grid_mode)) return 1;
/*   if ( !grid->xcor && strcmp(tag, "GRID_XCOR")) v_error(__FILE__,"GRID_DCOR is required before GRID_XCOR");
   if ( !grid->ycor && strcmp(tag, "GRID_YCOR")) v_error(__FILE__,"GRID_DCOR is required before GRID_YCOR");
*/   return 0;
   }
/*-----------------------------------------------------------*/
void  grid_struct_ini ( GRID_COR *grid, int size)
{   grid->alloc=grid->size=size;
    grid->valid=0;
    if (grid->xcor) free (grid->xcor);
    if (grid->ycor) free (grid->ycor);
    grid->xcor = (double *) prg_alloc (__FILE__, "xcor",grid->size*sizeof(double),1);
    grid->ycor = (double *) prg_alloc (__FILE__, "ycor",grid->size*sizeof(double),1);
    } 
/*-----------------------------------------------------------*/
void  grid_struct_def ( GRID_COR *grid, int size, int xo, int yo)
{   grid_struct_ini ( grid, size);
    grid->xcor[1]=1;
    grid->ycor[2]=1;
    grid->xcor[0]=xo;
    grid->ycor[0]=yo;
    grid->valid=grid->size=3;
    } 
/*-----------------------------------------------------------*/
void grid_cor_img ( GRID_COR *grid, IMAGE *img, int scale )
{  float  *surface;
   double *value;
   long sx,sy,sj;
   long tx,ty,tj;
   double x,xx,y,yy,v,s,surf;
   COUNTS *i_value = img->data;
   FRAMES *frame = img->frame;
   FRAMES *grid_frame;
   long tab[50],itab=0;
   printf ("\n#%s:grid_cor_img  '%s' size=%d(%dx%d)\n", __FILE__, img->name, 
            img->size,img->x_size,img->y_size);
   if (grid->size==0 || grid->valid!=3)
      v_error(__FILE__, "grid functions are not valid (look at .ini file)");
   surface = (float *) prg_alloc(__FILE__, "surface", img->size * sizeof(float), 1);
   value = (double *) prg_alloc(__FILE__, "corrected values", img->size * sizeof(double), 1);
   if ( ! i_value ) v_error(__FILE__, "no data in %s", img->name);
   grid_frame = (FRAMES *) prg_alloc(__FILE__, "frame", img->size * sizeof(FRAMES), 1);
   if (!grid_frame )
     if ( grid_mode && !strstr(grid_mode,"STRICT") ) 
           printf(" unable to alloc frame for grid correction and GRID_MODE not STRICT\n");
     else grid_mode="STRICT";
   for (sy=0; sy<img->y_size; sy++)
   {  for (sx=0,sj=sy*img->x_size; sx<img->x_size; sx++,sj++)
      {  long txb,txe,tyb,tye;
         double xb, xe, yb, ye, dxx, dyy;
         if (frame && frame[sj]==0) continue;
         x=grid_pix_xpos(sx, sy, grid);
         y=grid_pix_ypos(sx, sy, grid);
         dxx=grid_cor_dx(sx-grid->xcor[0], sy-grid->ycor[0], grid->xcor, grid->size);
         dyy=grid_cor_dy(sx-grid->xcor[0], sy-grid->ycor[0], grid->ycor, grid->size);
         surf=grid_pix_surf(sx, sy, grid);
         txb=xb=x-dxx/2;
         txe=xe=x+dxx/2;
         tyb=yb=y-dyy/2;
         tye=ye=y+dyy/2;
         for (tx=txb; tx<=txe;tx++)
         {  double dx;
            if(tx<0 || tx>=img->x_size) continue;
            if (xb < tx )
            {  if ( xe < tx )        continue;
               dx = ( xe <= tx+1 ) ? xe-tx : 1;
               }
            else if ( xb > tx+1 )   continue;
            else dx = ( xe <= tx+1 ) ? xe-xb : tx+1-xb;
            for (ty=tyb; ty<=tye;ty++)
            {  double dy;
               if(ty<0 || ty>=img->y_size) continue;
               if (yb < ty )
               {  if ( ye < ty )        continue;
                  dy = ( ye <= ty+1 ) ? ye-ty : 1;
                  }
               else if ( yb > ty+1 )   continue;
               else dy = ( ye <= ty+1 ) ? ye-yb : ty+1-yb;
               tj = ty*img->x_size+tx;
               s = dx*dy/surf;
               value[tj] += s * i_value[sj];
               surface[tj] += s*surf;
               if ( grid_frame ) grid_frame[tj]++;
            }  } /*for  tx, ty*/ 
      } }  /*for  sx, sy*/ 
   if ( grid_mode && strstr(grid_mode,"FLAT") )
   {  if ( grid_mode && strstr(grid_mode,"STRICT") )
      {  for (sj=0; sj<img->size; sj++) 
           if (surface[sj]) i_value[sj]=value[sj]/surface[sj]+0.5;
         else i_value[sj] = 0;
         if (grid_frame) for (sj=0; sj<img->size; sj++) 
             grid_frame[sj] = (surface[sj]) ? 1 : 0;
         }
      else   
      {  for (sj=0; sj<img->size; sj++) 
           if (surface[sj]>=0.5) i_value[sj]=value[sj]/surface[sj]+0.5;
           else i_value[sj] = 0;
         if (grid_frame) for (sj=0; sj<img->size; sj++) 
             grid_frame[sj] = (surface[sj]>=0.5) ? 1 : 0;
         }
      }
   else
   {  if ( grid_mode && strstr(grid_mode,"STRICT") )
      {  for (sj=0; sj<img->size; sj++) 
           if (surface[sj]) i_value[sj]=value[sj]+0.5;
           else i_value[sj] = 0;
         if (grid_frame) for (sj=0; sj<img->size; sj++) 
             grid_frame[sj] = (surface[sj]) ? 1 : 0;
         }
      else   
      {  tj = 0;
         for (sj=0; sj<img->size; sj++) 
           if (surface[sj]>=1.0) i_value[sj]=value[sj]+0.5;
           else  if ( surface[sj]>0.5) 
           {   i_value[sj]=value[sj]/surface[sj]+0.5;
               tj++;
               }   
           else i_value[sj]=0;
          if (grid_frame) for (sj=0; sj<img->size; sj++) 
             grid_frame[sj] = (surface[sj]<0.5) ? 0 : 1;
         printf ("# %d pixels corrected for border effects\n", tj);
         }
      }
   free(value);
   free(surface);
   if (img->frame) free(img->frame);
   img->frame=grid_frame;
   }
/*-----------------------------------------------------------*/
char * coef_grid_name(int i)
{
static char * grid_name[] = 
   {"1","x","y","xx","xy","yy","xxx","xxy","xyy","yyy",
             "xxxx","xxxy","xxyy","xyyy","yyyy",
             "xxxxx","xxxxy","xxxyy","xxyyy","xyyyy","yyyyy"};
   return grid_name[i];
   } 
/*-----------------------------------------------------------*/
double grid_cor_dx(double x, double y, double *cor, int size)
{  double res;
   int j;
   res = 0;
   for (j=0; j<size;j++)
   {  double c;
      switch (j)
     { case 1 : c=1; break;
       case 3 : c=2*x; break;
       case 4 : c=y; break;
       case 6 : c=3*x*x; break;
       case 7 : c=2*x*y; break;
       case 8 : c=y*y; break;
       case 10 : c=4*x*x*x; break;
       case 11 : c=3*x*x*y; break;
       case 12 : c=2*x*y*y; break;
       case 13 : c=y*y*y; break;
       case 15 : c=5*x*x*x*x; break;
       case 16 : c=4*x*x*x*y; break;
       case 17 : c=3*x*x*y*y; break;
       case 18 : c=2*x*y*y*y; break;
       case 19 : c=y*y*y*y; break;
       default : c =0; 
       }   
     res+=cor[j]*c;
     }
   return res;
   }
/*-----------------------------------------------------------*/
double grid_cor_dy(double x, double y, double *cor, int size)
{  double res;
   int j;
   res = 0;
   for (j=0; j<size;j++)
   {  double c;
      switch (j)
     { case 2 : c=1; break;
       case 4 : c=x; break;
       case 5 : c=2*y; break;
       case 7 : c=x*y; break;
       case 8 : c=2*y; break;
       case 9 : c=3*y*y; break;
       case 11 : c=x*x*x; break;
       case 12 : c=2*x*x*y; break;
       case 13 : c=3*x*y*y; break;
       case 14 : c=4*y*y*y; break;
       case 16 : c=x*x*x*x; break;
       case 17 : c=2*x*x*x*y; break;
       case 18 : c=3*x*x*y*y; break;
       case 19 : c=4*x*y*y*y; break;
       case 20 : c=5*y*y*y*y; break;
       default : c =0; 
       }   
     res+=cor[j]*c;
     }
   return res;
   }
/*-----------------------------------------------------------*/
double grid_pix_surf(int x, int y, GRID_COR *grid)
{  double dxx, dyx, dxy, dyy;
   double px, py;
   px=x-grid->xcor[0];
   py=y-grid->ycor[0];
   dxx=grid_cor_dx(px, py, grid->xcor, grid->size);
   dyy=grid_cor_dy(px, py, grid->ycor, grid->size);
   dxy=grid_cor_dy(px, py, grid->xcor, grid->size);
   dyx=grid_cor_dx(px, py, grid->ycor, grid->size);
   return dxx*dyy-dxy*dyx;
   }
/*-----------------------------------------------------------*/
double grid_pix_xpos(double x, double y, GRID_COR *grid)
{  x-=grid->xcor[0];
   y-=grid->ycor[0];
   return grid_cor_pos(x,y,grid->xcor,grid->size);
   }
/*-----------------------------------------------------------*/
double grid_pix_ypos(double x, double y, GRID_COR *grid)
{  x-=grid->xcor[0];
   y-=grid->ycor[0];
   return grid_cor_pos(x,y,grid->ycor,grid->size);
   }
/*-----------------------------------------------------------*/
double grid_cor_pos(double x, double y, double *cor, int size)
{  double res;
   int j;
   res = 0;
   for (j=0; j<size;j++) res+= cor[j]*grid_cor_der(j, x, y);
   return res;
   }
/*-----------------------------------------------------------*/
double grid_cor_der(int i, double x, double y)
{  switch (i)
   { case 0 : return 1;
     case 1 : return x;
     case 2 : return y;
     case 3 : return x*x;
     case 4 : return x*y;
     case 5 : return y*y;
     case 6 : return x*x*x;
     case 7 : return x*x*y;
     case 8 : return x*y*y;
     case 9 : return y*y*y;
     case 10 : return x*x*x*x;
     case 11 : return x*x*x*y;
     case 12 : return x*x*y*y;
     case 13 : return x*y*y*y;
     case 14 : return y*y*y*y;
     case 15 : return x*x*x*x*x;
     case 16 : return x*x*x*x*y;
     case 17 : return x*x*x*y*y;
     case 18 : return x*y*y*y*y;
     case 19 : return x*y*y*y*y;
     case 20 : return y*y*y*y*y;
   }
   return 0;
   }
/*-----------------------------------------------------------*/
